diff --git a/src/Fl_Text_Editor.cxx b/src/Fl_Text_Editor.cxx
index 2854bfa..95c0d07 100644
--- a/src/Fl_Text_Editor.cxx
+++ b/src/Fl_Text_Editor.cxx
@@ -228,9 +228,15 @@ int Fl_Text_Editor::kf_default(int c, Fl_Text_Editor* e) {
   if (!c || (!isprint(c) && c != '\t')) return 0;
   char s[2] = "\0";
   s[0] = (char)c;
-  kill_selection(e);
-  if (e->insert_mode()) e->insert(s);
-  else e->overstrike(s);
+  if (e->buffer()->selected()) {	// _replace_ selection
+    kill_selection(e);
+    e->insert(s);
+  } else {				// dependent on insert mode
+    if (e->insert_mode())
+      e->insert(s);
+    else
+      e->overstrike(s);
+  }
   e->show_insert_position();
   e->set_changed();
   if (e->when()&FL_WHEN_CHANGED) e->do_callback();
